unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, starsock, Inetmail, StdCtrls, Buttons, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Label2: TLabel;
    Label6: TLabel;
    Label1: TLabel;
    SendToEdit: TEdit;
    SubEdit: TEdit;
    CCEdit: TEdit;
    TextEdit: TRichEdit;
    Status: TStaticText;
    SendButton: TBitBtn;
    SMTPOptionButton: TBitBtn;
    CloseButton: TBitBtn;
    SendMail1: SendMail;
    ProgressBar1: TProgressBar;
    procedure CloseButtonClick(Sender: TObject);
    procedure SMTPOptionButtonClick(Sender: TObject);
    procedure SendButtonClick(Sender: TObject);
    procedure SendMail1MailError(Sender: TObject; error: SendMailError;
      addinfo: String);
    procedure SendMail1MailInfo(Sender: TObject; info: SendMailInfo;
      addinfo: String);
  private
    { Private declarations }
    todo, done: LongInt;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses SMTPOptDlg;

{$R *.dfm}

procedure TForm1.CloseButtonClick(Sender: TObject);
begin
 Close;
end;

procedure TForm1.SMTPOptionButtonClick(Sender: TObject);
begin
 SMTPOptForm.ShowModal;
end;

procedure TForm1.SendButtonClick(Sender: TObject);
var
 i:Integer;
begin
 if SMTPOptForm.SMTPEdit.Text='' then
  SMTPOptForm.ShowModal;
 SendMail1.FROM_Address:=SMTPOptForm.SendFromEdit.Text;
 SendMail1.SMTP_Server:=SMTPOptForm.SMTPEdit.Text;
 SendMail1.Port:=StrToIntDef(SMTPOptForm.PortEdit.Text,25);
 SendMail1.TO_Address:=SendToEdit.Text;
 SendMail1.Subject:=SubEdit.Text;

 SendMail1.Listcc.Clear;
 SendMail1.Listcc.Add(CCEdit.Text);

 SendMail1.MailText.Clear;
 for i:=0 to TextEdit.Lines.Count-1 do
  SendMail1.MailText.Add(TextEdit.Lines.Strings[i]);

 SendMail1.Attachments.Clear; 
// SendMail1.Attachments.Add('');
 SendMail1.Action:=Send_Mail;
end;

procedure TForm1.SendMail1MailError(Sender: TObject; error: SendMailError;
  addinfo: String);
begin
       case error of
       smNetworkUnreachable,smAddressNotAvailable,smHostUnreachable,smNetworkDown: Application.MessageBox('The network is '+
                'down. Make sure that you have established a connection to the network.',
                'Network Down Error',MB_OK+MB_ICONINFORMATION);

       smInvalidAddress,smAddressResolutionError: Application.MessageBox('CyD GIF Studio could not find your SMTP mail server. '+
                'Check that you are connected to your service provider and '+
                'that your setup information is correct.','Name Resolution Error',MB_OK+MB_ICONINFORMATION);
       smInternalError,smGeneralWinsockError,smUnknown: Application.MessageBox('An unexpected error occured',
                'Unexpected Error',MB_OK+MB_ICONINFORMATION);
       smPrematureDisconnect,smConnAborted,smConnReset: Application.MessageBox('The connection was unexpectedly closed by the'+
                ' remote server','Premature Disconnect Error',MB_OK+MB_ICONINFORMATION);
       smConnectTimeOut: Application.MessageBox('The connection attempt to the server timed out.','Connect Timeout Error',
                MB_OK+MB_ICONINFORMATION);
       smOutofSockets: Application.MessageBox('The winsock is out of sockets. Close a winsock application before trying '+
                'again.','Out of Sockets Error',MB_OK+MB_ICONINFORMATION);
       smConnectionRefused: Application.MessageBox('The mail server refused the connection. Make sure that you have '+
                'entered the correct value in setup for your SMTP server.','Connection Rejected Error',MB_OK+MB_ICONINFORMATION);
       smProtocolError: Application.MessageBox('An unexpected response was received from the mail server. Make sure that you '+
                'have entered the correct value in setup for your SMTP port.','Unexpected Response Error',MB_OK+MB_ICONINFORMATION);
       smCanceled:Application.MessageBox('The sending of mail was canceled.','Transaction Canceled',MB_OK+MB_ICONINFORMATION);
       smMailDestinationError: Application.MessageBox('No recipients were specified for the message.',
                'No Recipients Error',MB_OK+MB_ICONINFORMATION);
       end;
end;

procedure TForm1.SendMail1MailInfo(Sender: TObject; info: SendMailInfo;
  addinfo: String);
var
        l: longint;
begin
 case info of
  smResolvingAddress: Status.Caption:='Resolving '+addinfo;
  smAddressResolved: Status.Caption:='Connected to '+addinfo;
  smServerConnected: Status.Caption:='Connected to '+addinfo;
  smServerDisconnected: Status.Caption:='Disconnected, you may close this window';
  smSendingMessage:
   begin
    Status.Caption:='Sending Message';
    done:=StrToInt(addinfo);
    l:=(done*ProgressBar1.Max) div todo;
    ProgressBar1.Position:=l;
   end;
  smMessageSize: todo:=StrToInt(addinfo);
  smMessageAccepted: Status.Caption:='Message sent';
  smRecipient: Status.Caption:='To: '+addinfo;
  smBadAddress: Status.Caption:='Recipient '+addinfo+' Rejected!';
  smAttachmentName: Status.Caption:='Sending attachment '+addinfo;
  smAttachmentSize:
   begin
    todo:=StrToInt(addinfo);
    ProgressBar1.Position:=0;
   end;
  smAttachmentBytes:
   begin
    done:=StrToInt(addinfo);
    l:=(done*ProgressBar1.Max) div todo;
    ProgressBar1.Position:=l;
   end;
  end;
end;

end.
